/*
 * MasterTelescope.ino
    ver 10.5
 */
 void readModePin();
 void readDirectionPin();
 void sendSerialData();
 #include <SoftwareSerial.h>
 const byte westPin                      = 4 ;
 const byte northPin                     = 5 ;
 const byte eastPin                      = 7 ;
 const byte southPin                     = 8 ;
 const byte modePin                      = 6 ;
 const byte lowLedPin                    = A1;
 const byte med1LedPin                   = A2;
 const byte med2LedPin                   = A3;
 const byte highLedPin                   = A4;
 const byte rmotorPin                    = 9 ;
 const byte rdirPin                      = 10;
 const byte dmotorPin                    = 11;
 const byte ddirPin                      = 13;
 const byte rxpin                        = 2 ;
 const byte txpin                        = 3 ;
 byte  directionFlag                     = 0 ;
 byte  westPinState                      = 0 ;
 byte  lastwestPinState                  = 0 ;
 byte  northPinState                     = 0 ;
 byte  lastnorthPinState                 = 0 ;
 byte  eastPinState                      = 0 ;
 byte  lasteastPinState                  = 0 ;
 byte  southPinState                     = 0 ;
 byte  lastsouthPinState                 = 0 ;
 byte  currentModeSwitchState            = 0 ;
 byte  lastModeSwitchState               = 0 ;
 byte  mode                              = 0 ;
 unsigned long  currentMillis            = 0 ;
 unsigned long  lastMillis               = 0 ;
 volatile byte RmotorPin                 = 0 ;
 volatile byte DmotorPin                 = 0 ;
 volatile byte RdirPin                   = 0 ;
 volatile byte DdirPin                   = 0 ;
 SoftwareSerial serial_flip(txpin,rxpin);
 //****************************************************************
 void setup() 
 {
   pinMode(westPin, INPUT_PULLUP);
   pinMode(northPin,INPUT_PULLUP);
   pinMode(eastPin, INPUT_PULLUP);
   pinMode(southPin,INPUT_PULLUP);
   pinMode(modePin, INPUT_PULLUP);

   pinMode(lowLedPin, OUTPUT);
   pinMode(med1LedPin,OUTPUT);
   pinMode(med2LedPin,OUTPUT);
   pinMode(highLedPin,OUTPUT);
   
   pinMode(rmotorPin, OUTPUT);
   pinMode(rdirPin, OUTPUT);
   pinMode(dmotorPin, OUTPUT);
   pinMode(ddirPin, OUTPUT);

   Serial.begin(115200);
   serial_flip.begin(115200);

}
//                           LOOP
//****************************************************************
 void loop() 
 {
   currentMillis = millis();
   if(currentMillis - lastMillis >= 50)
    {
      lastMillis = currentMillis;
      readModePin();
      readDirectionPins();
      
    }
 }
 //                         readModePin 
 //***************************************************************
 void readModePin()
  {
    currentModeSwitchState = digitalRead(modePin);
    if(currentModeSwitchState != lastModeSwitchState)
    {
      lastModeSwitchState = currentModeSwitchState;
      if(currentModeSwitchState == LOW)
       {
        mode ++;
        if(mode > 4)
         {
          mode = 1;
         }
       }
      else
      {}
    }
     switch(mode)
      {
        case 1:
          digitalWrite(lowLedPin,HIGH);
          digitalWrite(med1LedPin,LOW);
          digitalWrite(med2LedPin,LOW);
          digitalWrite(highLedPin,LOW);
          break;

        case  2:
          digitalWrite(lowLedPin,  LOW);
          digitalWrite(med1LedPin,HIGH);
          digitalWrite(med2LedPin, LOW);
          digitalWrite(highLedPin, LOW);
          break;

        case  3:
          digitalWrite(lowLedPin,  LOW);
          digitalWrite(med1LedPin, LOW);
          digitalWrite(med2LedPin,HIGH);
          digitalWrite(highLedPin, LOW);
          break;
        
        case  4:
          digitalWrite(lowLedPin,  LOW);
          digitalWrite(med1LedPin, LOW);
          digitalWrite(med2LedPin, LOW);
          digitalWrite(highLedPin,HIGH);
          break;

        default:
          {}
      }
  }

 //**                                     readDirectionalPins
 //******************************************************************
 void readDirectionPins()
   {     //0 = none,  1 = west,  2 = north,  3 = east,  4 = south,  5 = reset
     westPinState = digitalRead(westPin);
     if(westPinState != lastwestPinState)
      {
        lastwestPinState = westPinState;
        if(westPinState == LOW)
         {
          directionFlag = 1;
          RdirPin = LOW;
          DdirPin = LOW;
         }
        else
         {
          directionFlag = 5;
          RmotorPin = 0;
          DmotorPin = 0;
          RdirPin = LOW;
          DdirPin = LOW;
         }
      }
 //********************************************************************************
     northPinState = digitalRead(northPin);
     if(northPinState != lastnorthPinState)
      {
        lastnorthPinState = northPinState;
        if(northPinState == LOW)
         {
           directionFlag = 2;
           RdirPin = LOW;
           DdirPin = LOW;
         }
        else
         {
           directionFlag = 5;
           RmotorPin = 0;
           DmotorPin = 0;
           RdirPin = LOW;
           DdirPin = LOW;
         }
      }
  //*************************************************************************************
     eastPinState = digitalRead(eastPin);
     if(eastPinState != lasteastPinState)
      {
        lasteastPinState = eastPinState;
        if(eastPinState ==LOW)
         {
           directionFlag = 3;
           RdirPin = HIGH;
           DdirPin = LOW;
         }
        else
         {
           directionFlag = 5;
           RmotorPin = 0;
           DmotorPin = 0;
           RdirPin =LOW;
           DdirPin = LOW;
         }
      }
 //**********************************************************************
     southPinState = digitalRead(southPin);
     if(southPinState != lastsouthPinState)
      {
        lastsouthPinState = southPinState;
        if(southPinState == LOW)
         {
          directionFlag = 4;
          RdirPin = LOW;
          DdirPin = HIGH;
         }
        else
         {
           directionFlag = 5;
           RmotorPin = 0;
           DmotorPin = 0;
           RdirPin = LOW;
           DdirPin = LOW;
         }
      }
 //******************************************************************************
   if(directionFlag != 0)
    {
      switch (mode)
       {
        // mode 1
        case 1:
         switch (directionFlag)
          {
            // mode 1
            case 1:
             {
               RmotorPin     = 100;
               DmotorPin     =   0;
               directionFlag = 0;
             }
               break;
            case 2:
             {
               RmotorPin     =   0;
               DmotorPin     =  75;
               directionFlag =   0; 
             }
               break;
            case 3:
             {
               RmotorPin     = 100;
               DmotorPin     =   0;
               directionFlag =   0;
             }
               break;
            case 4:
             {
               RmotorPin     =   0;
               DmotorPin     =  75;
               directionFlag =   0;
             }
               break;
          }
            break;
 //***************************************************************************
    // mode 2:
    case 2:
     switch(directionFlag)
      {  // mode 2 west
         case 1:
         {
           RmotorPin     = 150;
           DmotorPin     =   0;
           directionFlag =   0;
         }
           break;
         case 2:
         {
           RmotorPin     =   0;
           DmotorPin     = 100;
           directionFlag =   0;
         }
           break;
         case 3:
         {
           RmotorPin     = 150;
           DmotorPin     =   0;
           directionFlag =   0;
         }
           break;
         case 4:
         {
           RmotorPin     =   0;
           DmotorPin     = 100;
           directionFlag =   0;
         }
           break;
       }
         break;
 //********************************************************************************
    //  mode 3:
    case 3:
     switch(directionFlag)
      {  // mode 3 west
         case 1:
         {
           RmotorPin     = 200;
           DmotorPin     =   0;
           directionFlag =   0;
         }
           break;
         case 2:
         {
           RmotorPin     =   0;
           DmotorPin     = 150;
           directionFlag =   0;
         }
           break;
         case 3:
         {
           RmotorPin     = 200;
           DmotorPin     =   0;
           directionFlag =   0;
         }
           break;
         case 4:
         {
           RmotorPin     =   0;
           DmotorPin     = 150;
           directionFlag =   0;
         }
           break;
      }
        break;
 //*********************************************************************************
    //  mode 4:
    case 4:
     switch(directionFlag)
     {  //  west
        case 1:
        {
          RmotorPin     = 250;
          DmotorPin     =   0;
          directionFlag =   0;   
        }
          break;
        case 2:
        {
          RmotorPin     =   0;
          DmotorPin     = 200;
          directionFlag =   0;
        }
           break;
        case 3:
        {
          RmotorPin     = 250;
          DmotorPin     =   0;
          directionFlag =   0;
        }
          break;
        
         case 4:
         {
           RmotorPin     =   0;
           DmotorPin     = 200;
           directionFlag =   0;
         }
           break;
       }
         break;   
     }
      
//************************************************************************************
    if(directionFlag ==5)
     {
      directionFlag = 0;
     }
     sendSerialData();sprintf;
   }
 }
//***************************************************************************************
 void sendSerialData()
   {
    
     serial_flip.write(RmotorPin);
     serial_flip.write(RdirPin);
     serial_flip.write(DmotorPin);
     serial_flip.write(DdirPin);
     
     Serial.write(RmotorPin);
     Serial.write(RdirPin);
     Serial.write(DmotorPin);
     Serial.write(DdirPin);

     Serial.print("value1");
     Serial.println(RmotorPin,DEC);
     Serial.print("value2");
     Serial.println(RdirPin,DEC);
     Serial.print( "value3");
     Serial.println(DmotorPin,DEC);
     Serial.print("value4");
     Serial.println(DdirPin,DEC);
     
   }
    
 
